//+------------------------------------------------------------------+
//|                                      PositionPropertiesPanel.mq5 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//---
#define INFOPANEL_SIZE 14 //     -
#define EXPERT_NAME MQL5InfoString(MQL5_PROGRAM_NAME) //  
//---    
#include <Trade/Trade.mqh>
//---  
bool                 pos_open=false;         //  /  
string               pos_symbol="";          // 
long                 pos_magic=0;            //  
string               pos_comment="";         // 
double               pos_swap=0.0;           // 
double               pos_commission=0.0;     // 
double               pos_price=0.0;          //  
double               pos_cprice=0.0;         //   
double               pos_profit=0.0;         // / 
double               pos_volume=0.0;         //  
double               pos_sl=0.0;             // Stop Loss 
double               pos_tp=0.0;             // Take Profit 
datetime             pos_time=NULL;          //   
long                 pos_id=0;               //  
ENUM_POSITION_TYPE   pos_type=WRONG_VALUE;   //  
//---  
int                  sym_digits=0;           //      
int                  sym_spread=0;           //    
int                  sym_stops_level=0;      //   Stop 
double               sym_point=0.0;          //   
double               sym_ask=0.0;            //  ask
double               sym_bid=0.0;            //  bid
double               sym_volume_min=0.0;     //     
double               sym_volume_max=0.0;     //     
double               sym_volume_limit=0.0;   //          
double               sym_volume_step=0.0;    //       
double               sym_offset=0.0;         //       
double               sym_up_level=0.0;       //    stop level
double               sym_down_level=0.0;     //    stop level
//---   ,    
string pos_prop_names[INFOPANEL_SIZE]=
  {
   "name_pos_symbol",
   "name_pos_magic",
   "name_pos_comment",
   "name_pos_swap",
   "name_pos_commission",
   "name_pos_price",
   "name_pos_cprice",
   "name_pos_profit",
   "name_pos_volume",
   "name_pos_sl",
   "name_pos_tp",
   "name_pos_time",
   "name_pos_id",
   "name_pos_type"
  };
//---   ,    
string pos_prop_values[INFOPANEL_SIZE]=
  {
   "value_pos_symbol",
   "value_pos_magic",
   "value_pos_comment",
   "value_pos_swap",
   "value_pos_commission",
   "value_pos_price",
   "value_pos_cprice",
   "value_pos_profit",
   "value_pos_volume",
   "value_pos_sl",
   "value_pos_tp",
   "value_pos_time",
   "value_pos_id",
   "value_pos_type"
  };
//---    
string pos_prop_texts[INFOPANEL_SIZE]=
  {
   "Symbol :",
   "Magic Number :",
   "Comment :",
   "Swap :",
   "Commission :",
   "Open Price :",
   "Current Price :",
   "Profit :",
   "Volume :",
   "Stop Loss :",
   "Take Profit :",
   "Time :",
   "Identifier :",
   "Type :"
  };
//---   
double               close_price[]; // Close (  )
double               open_price[];  // Open (  )
double               high_price[];  // High (  )
double               low_price[];   // Open (  )
//---   
enum ENUM_POSITION_PROPERTIES
  {
   P_SYMBOL        = 0,
   P_MAGIC         = 1,
   P_COMMENT       = 2,
   P_SWAP          = 3,
   P_COMMISSION    = 4,
   P_PRICE_OPEN    = 5,
   P_PRICE_CURRENT = 6,
   P_PROFIT        = 7,
   P_VOLUME        = 8,
   P_SL            = 9,
   P_TP            = 10,
   P_TIME          = 11,
   P_ID            = 12,
   P_TYPE          = 13,
   P_ALL           = 14
  };
//---   
enum ENUM_SYMBOL_PROPERTIES
  {
   S_DIGITS       = 0,
   S_SPREAD       = 1,
   S_STOPSLEVEL   = 2,
   S_POINT        = 3,
   S_ASK          = 4,
   S_BID          = 5,
   S_VOLUME_MIN   = 6,
   S_VOLUME_MAX   = 7,
   S_VOLUME_LIMIT = 8,
   S_VOLUME_STEP  = 9,
   S_FILTER       = 10,
   S_UP_LEVEL     = 11,
   S_DOWN_LEVEL   = 12,
   S_ALL          = 13
  };
//---   
input int            NumberOfBars=2;     // - /   /
input double         Lot         =0.1;   // 
input double         StopLoss    =50;    //  
input double         TakeProfit  =100;   //  
input double         TrailingStop=10;    //  
input bool           Reverse     =true;  //  
//---      NumberOfBars
int                  AllowedNumberOfBars=0;
//---  
CTrade trade;
//+------------------------------------------------------------------+
//|                                                |
//+------------------------------------------------------------------+
bool CheckNewBar()
  {
//---      
   static datetime new_bar=NULL;
//---       
   static datetime time_last_bar[1]={0};
//---     
//        ,   
   if(CopyTime(_Symbol,Period(),0,1,time_last_bar)==-1)
     { Print(__FUNCTION__,":     : "+IntegerToString(GetLastError())+""); }
//---     
   if(new_bar==NULL)
     {
      //  
      new_bar=time_last_bar[0];
      Print(__FUNCTION__,":  ["+_Symbol+"][TF: "+TimeframeToString(Period())+"]["
            +TimeToString(time_last_bar[0],TIME_DATE|TIME_MINUTES|TIME_SECONDS)+"]");
      return(false); //  false   
     }
//---   
   if(new_bar!=time_last_bar[0])
     {
      new_bar=time_last_bar[0]; //     
      return(true); //     true
     }
//---     -    ,  false
   return(false);
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
string TimeframeToString(ENUM_TIMEFRAMES timeframe)
  {
   string str="";
//---    ,    
   if(timeframe==WRONG_VALUE|| timeframe== NULL)
      timeframe= Period();
   switch(timeframe)
     {
      case PERIOD_M1  : str="M1";  break;
      case PERIOD_M2  : str="M2";  break;
      case PERIOD_M3  : str="M3";  break;
      case PERIOD_M4  : str="M4";  break;
      case PERIOD_M5  : str="M5";  break;
      case PERIOD_M6  : str="M6";  break;
      case PERIOD_M10 : str="M10"; break;
      case PERIOD_M12 : str="M12"; break;
      case PERIOD_M15 : str="M15"; break;
      case PERIOD_M20 : str="M20"; break;
      case PERIOD_M30 : str="M30"; break;
      case PERIOD_H1  : str="H1";  break;
      case PERIOD_H2  : str="H2";  break;
      case PERIOD_H3  : str="H3";  break;
      case PERIOD_H4  : str="H4";  break;
      case PERIOD_H6  : str="H6";  break;
      case PERIOD_H8  : str="H8";  break;
      case PERIOD_H12 : str="H12"; break;
      case PERIOD_D1  : str="D1";  break;
      case PERIOD_W1  : str="W1";  break;
      case PERIOD_MN1 : str="MN1"; break;
     }
//---
   return(str);
  }
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
void GetBarsData()
  {
//---        
   if(NumberOfBars<=1)
      AllowedNumberOfBars=2;              //     
   if(NumberOfBars>=5)
      AllowedNumberOfBars=5;              //    5
   else
      AllowedNumberOfBars=NumberOfBars+1; //     
//---     (... 3 2 1 0)
   ArraySetAsSeries(close_price,true);
   ArraySetAsSeries(open_price,true);
   ArraySetAsSeries(high_price,true);
   ArraySetAsSeries(low_price,true);
//---    
//       ,  ,    
   if(CopyClose(_Symbol,Period(),0,AllowedNumberOfBars,close_price)<AllowedNumberOfBars)
     {
      Print("    ("
            +_Symbol+", "+TimeframeToString(Period())+")    Close! "
            " "+IntegerToString(GetLastError())+": "+ErrorDescription(GetLastError()));
     }
//---    
//       ,  ,    
   if(CopyOpen(_Symbol,Period(),0,AllowedNumberOfBars,open_price)<AllowedNumberOfBars)
     {
      Print("    ("
            +_Symbol+", "+TimeframeToString(Period())+")    Open! "
            " "+IntegerToString(GetLastError())+": "+ErrorDescription(GetLastError()));
     }
//---    
//       ,  ,    
   if(CopyHigh(_Symbol,Period(),0,AllowedNumberOfBars,high_price)<AllowedNumberOfBars)
     {
      Print("    ("
            +_Symbol+", "+TimeframeToString(Period())+")    High! "
            " "+IntegerToString(GetLastError())+": "+ErrorDescription(GetLastError()));
     }
//---    
//       ,  ,    
   if(CopyLow(_Symbol,Period(),0,AllowedNumberOfBars,low_price)<AllowedNumberOfBars)
     {
      Print("    ("
            +_Symbol+", "+TimeframeToString(Period())+")    Low! "
            " "+IntegerToString(GetLastError())+": "+ErrorDescription(GetLastError()));
     }
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
ENUM_ORDER_TYPE GetTradingSignal()
  {
//---    (ORDER_TYPE_BUY) :
   if(AllowedNumberOfBars==2 && 
      close_price[1]>open_price[1])
      return(ORDER_TYPE_BUY);
   if(AllowedNumberOfBars==3 && 
      close_price[1]>open_price[1] && 
      close_price[2]>open_price[2])
      return(ORDER_TYPE_BUY);
   if(AllowedNumberOfBars==4 && 
      close_price[1]>open_price[1] && 
      close_price[2]>open_price[2] && 
      close_price[3]>open_price[3])
      return(ORDER_TYPE_BUY);
   if(AllowedNumberOfBars==5 && 
      close_price[1]>open_price[1] && 
      close_price[2]>open_price[2] && 
      close_price[3]>open_price[3] && 
      close_price[4]>open_price[4])
      return(ORDER_TYPE_BUY);
   if(AllowedNumberOfBars>=6 && 
      close_price[1]>open_price[1] && 
      close_price[2]>open_price[2] && 
      close_price[3]>open_price[3] && 
      close_price[4]>open_price[4] && 
      close_price[5]>open_price[5])
      return(ORDER_TYPE_BUY);
//---    (ORDER_TYPE_SELL) :
   if(AllowedNumberOfBars==2 && 
      close_price[1]<open_price[1])
      return(ORDER_TYPE_SELL);
   if(AllowedNumberOfBars==3 && 
      close_price[1]<open_price[1] && 
      close_price[2]<open_price[2])
      return(ORDER_TYPE_SELL);
   if(AllowedNumberOfBars==4 && 
      close_price[1]<open_price[1] && 
      close_price[2]<open_price[2] && 
      close_price[3]<open_price[3])
      return(ORDER_TYPE_SELL);
   if(AllowedNumberOfBars==5 && 
      close_price[1]<open_price[1] && 
      close_price[2]<open_price[2] && 
      close_price[3]<open_price[3] && 
      close_price[4]<open_price[4])
      return(ORDER_TYPE_SELL);
   if(AllowedNumberOfBars>=6 && 
      close_price[1]<open_price[1] && 
      close_price[2]<open_price[2] && 
      close_price[3]<open_price[3] && 
      close_price[4]<open_price[4] && 
      close_price[5]<open_price[5])
      return(ORDER_TYPE_SELL);
//---   (WRONG_VALUE):
   return(WRONG_VALUE);
  }
//+------------------------------------------------------------------+
//|                                                      |
//+------------------------------------------------------------------+
void TradingBlock()
  {
   ENUM_ORDER_TYPE      signal=WRONG_VALUE;                 //    
   string               comment="hello :)";                 //   
   double               tp=0.0;                             // Take Profit
   double               sl=0.0;                             // Stop Loss
   double               lot=0.0;                            //        
   double               position_open_price=0.0;            //   
   ENUM_ORDER_TYPE      order_type=WRONG_VALUE;             //     
   ENUM_POSITION_TYPE   opposite_position_type=WRONG_VALUE; //   
//---  
   signal=GetTradingSignal();
//---   , 
   if(signal==WRONG_VALUE)
      return;
//--- ,   
   pos_open=PositionSelect(_Symbol);
//---    
   GetSymbolProperties(S_ALL);
//---    
   switch(signal)
     {
      //---     BUY
      case ORDER_TYPE_BUY  :
         position_open_price=sym_ask;
         order_type=ORDER_TYPE_BUY;
         opposite_position_type=POSITION_TYPE_SELL;
         break;
         //---     SELL
      case ORDER_TYPE_SELL :
         position_open_price=sym_bid;
         order_type=ORDER_TYPE_SELL;
         opposite_position_type=POSITION_TYPE_BUY;
         break;
     }
//---   Take Profit  Stop Loss
   sl=CalculateStopLoss(order_type);
   tp=CalculateTakeProfit(order_type);
//---   
   if(!pos_open)
     {
      //---  
      lot=CalculateLot(Lot);
      //---  
      //       ,    
      if(!trade.PositionOpen(_Symbol,order_type,lot,position_open_price,sl,tp,comment))
        {
         Print("   : ",GetLastError()," - ",ErrorDescription(GetLastError()));
        }
     }
//---   
   else
     {
      //---   
      GetPositionProperties(P_TYPE);
      //---        
      if(pos_type==opposite_position_type && Reverse)
        {
         //---   
         GetPositionProperties(P_VOLUME);
         //---  
         lot=pos_volume+CalculateLot(Lot);
         //---  .    ,    
         if(!trade.PositionOpen(_Symbol,order_type,lot,position_open_price,sl,tp,comment))
           {
            Print("   : ",GetLastError()," - ",ErrorDescription(GetLastError()));
           }
        }
     }
//---
   return;
  }
//+------------------------------------------------------------------+
//|   Edit                                              |
//+------------------------------------------------------------------+
void CreateEdit(long             chart_id,         // id 
                int              sub_window,       //   ()
                string           name,             //  
                string           text,             //  
                ENUM_BASE_CORNER corner,           //  
                string           font_name,        // 
                int              font_size,        //  
                color            font_color,       //  
                int              x_size,           // 
                int              y_size,           // 
                int              x_distance,       //    X
                int              y_distance,       //    Y
                long             z_order,          // 
                color            background_color, //  
                bool             read_only)        //  "  "
  {
//    , ...
   if(ObjectCreate(chart_id,name,OBJ_EDIT,sub_window,0,0))
     {
      // ...  
      ObjectSetString(chart_id,name,OBJPROP_TEXT,text);                 //  
      ObjectSetInteger(chart_id,name,OBJPROP_CORNER,corner);            //   
      ObjectSetString(chart_id,name,OBJPROP_FONT,font_name);            //  
      ObjectSetInteger(chart_id,name,OBJPROP_FONTSIZE,font_size);       //   
      ObjectSetInteger(chart_id,name,OBJPROP_COLOR,font_color);         //  
      ObjectSetInteger(chart_id,name,OBJPROP_BGCOLOR,background_color); //  
      ObjectSetInteger(chart_id,name,OBJPROP_XSIZE,x_size);             // 
      ObjectSetInteger(chart_id,name,OBJPROP_YSIZE,y_size);             // 
      ObjectSetInteger(chart_id,name,OBJPROP_XDISTANCE,x_distance);     //   X
      ObjectSetInteger(chart_id,name,OBJPROP_YDISTANCE,y_distance);     //   Y
      ObjectSetInteger(chart_id,name,OBJPROP_SELECTABLE,false);         //   ,  FALSE
      ObjectSetInteger(chart_id,name,OBJPROP_ZORDER,z_order);           //  
      ObjectSetInteger(chart_id,name,OBJPROP_READONLY,read_only);       //   
      ObjectSetInteger(chart_id,name,OBJPROP_ALIGN,ALIGN_LEFT);         //    
      ObjectSetString(chart_id,name,OBJPROP_TOOLTIP,"\n");              //   ,  "\n"
     }
  }
//+------------------------------------------------------------------+
//|   Label                                             |
//+------------------------------------------------------------------+
void CreateLabel(long               chart_id,   // id 
                 int                sub_window, //   ()
                 string             name,       //  
                 string             text,       //  
                 ENUM_ANCHOR_POINT  anchor,     //  
                 ENUM_BASE_CORNER   corner,     //  
                 string             font_name,  // 
                 int                font_size,  //  
                 color              font_color, //  
                 int                x_distance, //    X
                 int                y_distance, //    Y
                 long               z_order)    // 
  {
//    , ...
   if(ObjectCreate(chart_id,name,OBJ_LABEL,sub_window,0,0))
     {
      // ...  
      ObjectSetString(chart_id,name,OBJPROP_TEXT,text);              //  
      ObjectSetString(chart_id,name,OBJPROP_FONT,font_name);         //  
      ObjectSetInteger(chart_id,name,OBJPROP_COLOR,font_color);      //   
      ObjectSetInteger(chart_id,name,OBJPROP_ANCHOR,anchor);         //   
      ObjectSetInteger(chart_id,name,OBJPROP_CORNER,corner);         //   
      ObjectSetInteger(chart_id,name,OBJPROP_FONTSIZE,font_size);    //   
      ObjectSetInteger(chart_id,name,OBJPROP_XDISTANCE,x_distance);  //   X
      ObjectSetInteger(chart_id,name,OBJPROP_YDISTANCE,y_distance);  //   Y
      ObjectSetInteger(chart_id,name,OBJPROP_SELECTABLE,false);      //   ,  FALSE
      ObjectSetInteger(chart_id,name,OBJPROP_ZORDER,z_order);        //  
      ObjectSetString(chart_id,name,OBJPROP_TOOLTIP,"\n");           //   ,  "\n"
     }
  }
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
void DeleteObjectByName(string name)
  {
   int  sub_window=0;      //   ,    
   bool res       =false;  //     
//---    
   sub_window=ObjectFind(ChartID(),name);
//---
   if(sub_window>=0) //  ,..
     {
      res=ObjectDelete(ChartID(),name); // ... 
      //---
      //     ,   
      if(!res)
         Print("   : ("+IntegerToString(GetLastError())+"): "+ErrorDescription(GetLastError()));
     }
  }
//+------------------------------------------------------------------+
//|                                  |
//+------------------------------------------------------------------+
void ZeroPositionProperties()
  {
   pos_symbol     ="";
   pos_comment    ="";
   pos_magic      =0;
   pos_price      =0.0;
   pos_cprice     =0.0;
   pos_sl         =0.0;
   pos_tp         =0.0;
   pos_type       =WRONG_VALUE;
   pos_volume     =0.0;
   pos_commission =0.0;
   pos_swap       =0.0;
   pos_profit     =0.0;
   pos_time       =NULL;
   pos_id         =0;
  }
//+------------------------------------------------------------------+
//|                                      |
//+------------------------------------------------------------------+
string PositionTypeToString(ENUM_POSITION_TYPE type)
  {
   string str="";
//---
   if(type==POSITION_TYPE_BUY)
      str="buy";
   else if(type==POSITION_TYPE_SELL)
      str="sell";
   else
      str="wrong value";
//---
   return(str);
  }
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
void GetPositionProperties(ENUM_POSITION_PROPERTIES position_property)
  {
//--- ,   
   pos_open=PositionSelect(_Symbol);
//---   ,   
   if(pos_open)
     {
      switch(position_property)
        {
         case P_SYMBOL        : pos_symbol=PositionGetString(POSITION_SYMBOL);                  break;
         case P_MAGIC         : pos_magic=PositionGetInteger(POSITION_MAGIC);                   break;
         case P_COMMENT       : pos_comment=PositionGetString(POSITION_COMMENT);                break;
         case P_SWAP          : pos_swap=PositionGetDouble(POSITION_SWAP);                      break;
         case P_COMMISSION    : pos_commission=PositionGetDouble(POSITION_COMMISSION);          break;
         case P_PRICE_OPEN    : pos_price=PositionGetDouble(POSITION_PRICE_OPEN);               break;
         case P_PRICE_CURRENT : pos_cprice=PositionGetDouble(POSITION_PRICE_CURRENT);           break;
         case P_PROFIT        : pos_profit=PositionGetDouble(POSITION_PROFIT);                  break;
         case P_VOLUME        : pos_volume=PositionGetDouble(POSITION_VOLUME);                  break;
         case P_SL            : pos_sl=PositionGetDouble(POSITION_SL);                          break;
         case P_TP            : pos_tp=PositionGetDouble(POSITION_TP);                          break;
         case P_TIME          : pos_time=(datetime)PositionGetInteger(POSITION_TIME);           break;
         case P_ID            : pos_id=PositionGetInteger(POSITION_IDENTIFIER);                 break;
         case P_TYPE          : pos_type=(ENUM_POSITION_TYPE)PositionGetInteger(POSITION_TYPE); break;
         case P_ALL           :
            pos_symbol=PositionGetString(POSITION_SYMBOL);
            pos_magic=PositionGetInteger(POSITION_MAGIC);
            pos_comment=PositionGetString(POSITION_COMMENT);
            pos_swap=PositionGetDouble(POSITION_SWAP);
            pos_commission=PositionGetDouble(POSITION_COMMISSION);
            pos_price=PositionGetDouble(POSITION_PRICE_OPEN);
            pos_cprice=PositionGetDouble(POSITION_PRICE_CURRENT);
            pos_profit=PositionGetDouble(POSITION_PROFIT);
            pos_volume=PositionGetDouble(POSITION_VOLUME);
            pos_sl=PositionGetDouble(POSITION_SL);
            pos_tp=PositionGetDouble(POSITION_TP);
            pos_time=(datetime)PositionGetInteger(POSITION_TIME);
            pos_id=PositionGetInteger(POSITION_IDENTIFIER);
            pos_type=(ENUM_POSITION_TYPE)PositionGetInteger(POSITION_TYPE);                     break;
         default: Print("      !");               return;
        }
     }
//---   ,    
   else
      ZeroPositionProperties();
  }
//+------------------------------------------------------------------+
//|        (int)             |
//+------------------------------------------------------------------+
int CorrectValueBySymbolDigits(int value)
  {
   return(sym_digits==3 || sym_digits==5) ? value*=10 : value;
  }
//+------------------------------------------------------------------+
//|        (double)          |
//+------------------------------------------------------------------+
double CorrectValueBySymbolDigits(double value)
  {
   return(sym_digits==3 || sym_digits==5) ? value*=10 : value;
  }
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
void GetSymbolProperties(ENUM_SYMBOL_PROPERTIES symbol_property)
  {
   int lot_offset=1; //       stops level
//---
   switch(symbol_property)
     {
      case S_DIGITS        : sym_digits=(int)SymbolInfoInteger(_Symbol,SYMBOL_DIGITS);                   break;
      case S_SPREAD        : sym_spread=(int)SymbolInfoInteger(_Symbol,SYMBOL_SPREAD);                   break;
      case S_STOPSLEVEL    : sym_stops_level=(int)SymbolInfoInteger(_Symbol,SYMBOL_TRADE_STOPS_LEVEL);   break;
      case S_POINT         : sym_point=SymbolInfoDouble(_Symbol,SYMBOL_POINT);                           break;
      //---
      case S_ASK           :
         sym_digits=(int)SymbolInfoInteger(_Symbol,SYMBOL_DIGITS);
         sym_ask=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),sym_digits);                       break;
      case S_BID           :
         sym_digits=(int)SymbolInfoInteger(_Symbol,SYMBOL_DIGITS);
         sym_bid=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),sym_digits);                       break;
         //---
      case S_VOLUME_MIN    : sym_volume_min=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN);                 break;
      case S_VOLUME_MAX    : sym_volume_max=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MAX);                 break;
      case S_VOLUME_LIMIT  : sym_volume_limit=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_LIMIT);             break;
      case S_VOLUME_STEP   : sym_volume_step=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_STEP);               break;
      //---
      case S_FILTER        :
         sym_digits=(int)SymbolInfoInteger(_Symbol,SYMBOL_DIGITS);
         sym_point=SymbolInfoDouble(_Symbol,SYMBOL_POINT);
         sym_offset=NormalizeDouble(CorrectValueBySymbolDigits(lot_offset*sym_point),sym_digits);        break;
         //---
      case S_UP_LEVEL      :
         sym_digits=(int)SymbolInfoInteger(_Symbol,SYMBOL_DIGITS);
         sym_stops_level=(int)SymbolInfoInteger(_Symbol,SYMBOL_TRADE_STOPS_LEVEL);
         sym_point=SymbolInfoDouble(_Symbol,SYMBOL_POINT);
         sym_ask=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),sym_digits);
         sym_up_level=NormalizeDouble(sym_ask+sym_stops_level*sym_point,sym_digits);                     break;
         //---
      case S_DOWN_LEVEL    :
         sym_digits=(int)SymbolInfoInteger(_Symbol,SYMBOL_DIGITS);
         sym_stops_level=(int)SymbolInfoInteger(_Symbol,SYMBOL_TRADE_STOPS_LEVEL);
         sym_point=SymbolInfoDouble(_Symbol,SYMBOL_POINT);
         sym_bid=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),sym_digits);
         sym_down_level=NormalizeDouble(sym_bid-sym_stops_level*sym_point,sym_digits);                   break;
         //---
      case S_ALL           :
         sym_digits=(int)SymbolInfoInteger(_Symbol,SYMBOL_DIGITS);
         sym_spread=(int)SymbolInfoInteger(_Symbol,SYMBOL_SPREAD);
         sym_stops_level=(int)SymbolInfoInteger(_Symbol,SYMBOL_TRADE_STOPS_LEVEL);
         sym_point=SymbolInfoDouble(_Symbol,SYMBOL_POINT);
         sym_ask=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),sym_digits);
         sym_bid=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),sym_digits);
         sym_volume_min=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN);
         sym_volume_max=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MAX);
         sym_volume_limit=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_LIMIT);
         sym_volume_step=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_STEP);
         sym_offset=NormalizeDouble(CorrectValueBySymbolDigits(lot_offset*sym_point),sym_digits);
         sym_up_level=NormalizeDouble(sym_ask+sym_stops_level*sym_point,sym_digits);
         sym_down_level=NormalizeDouble(sym_bid-sym_stops_level*sym_point,sym_digits);                   break;
         //---
      default: Print("      !"); return;
     }
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
double CalculateLot(double lot)
  {
//---     
   double corrected_lot=0.0;
//---
   GetSymbolProperties(S_VOLUME_MIN);  //    
   GetSymbolProperties(S_VOLUME_MAX);  //    
   GetSymbolProperties(S_VOLUME_STEP); //   / 
//---     
   corrected_lot=MathRound(lot/sym_volume_step)*sym_volume_step;
//---   ,  
   if(corrected_lot<sym_volume_min)
      return(NormalizeDouble(sym_volume_min,2));
//---   ,  
   if(corrected_lot>sym_volume_max)
      return(NormalizeDouble(sym_volume_max,2));
//---
   return(NormalizeDouble(corrected_lot,2));
  }
//+------------------------------------------------------------------+
//|   Take Profit                                 |
//+------------------------------------------------------------------+
double CalculateTakeProfit(ENUM_ORDER_TYPE order_type)
  {
//---  Take Profit 
   if(TakeProfit>0)
     {
      //---    Take Profit
      double tp=0.0;
      //---       SELL
      if(order_type==ORDER_TYPE_SELL)
        {
         //---  
         tp=NormalizeDouble(sym_bid-CorrectValueBySymbolDigits(TakeProfit*sym_point),sym_digits);
         //---   ,      stops level
         //        ,   
         return(tp<sym_down_level ? tp : sym_down_level-sym_offset);
        }
      //---       BUY
      if(order_type==ORDER_TYPE_BUY)
        {
         //---  
         tp=NormalizeDouble(sym_ask+CorrectValueBySymbolDigits(TakeProfit*sym_point),sym_digits);
         //---   ,      stops level
         //        ,   
         return(tp>sym_up_level ? tp : sym_up_level+sym_offset);
        }
     }
//---
   return(0.0);
  }
//+------------------------------------------------------------------+
//|   Stop Loss                                   |
//+------------------------------------------------------------------+
double CalculateStopLoss(ENUM_ORDER_TYPE order_type)
  {
//---  Stop Loss 
   if(StopLoss>0)
     {
      //---    Stop Loss
      double sl=0.0;
      //---       BUY
      if(order_type==ORDER_TYPE_BUY)
        {
         //  
         sl=NormalizeDouble(sym_ask-CorrectValueBySymbolDigits(StopLoss*sym_point),sym_digits);
         //---   ,      stops level
         //        ,   
         return(sl<sym_down_level ? sl : sym_down_level-sym_offset);
        }
      //---       SELL
      if(order_type==ORDER_TYPE_SELL)
        {
         //---  
         sl=NormalizeDouble(sym_bid+CorrectValueBySymbolDigits(StopLoss*sym_point),sym_digits);
         //---   ,      stops level
         //        ,   
         return(sl>sym_up_level ? sl : sym_up_level+sym_offset);
        }
     }
//---
   return(0.0);
  }
//+------------------------------------------------------------------+
//|   Trailing Stop                               |
//+------------------------------------------------------------------+
double CalculateTrailingStop(ENUM_POSITION_TYPE position_type)
  {
//---   
   double            level       =0.0;
   double            buy_point   =low_price[1];    //  Low  Buy
   double            sell_point  =high_price[1];   //  High  Sell
//---     BUY
   if(position_type==POSITION_TYPE_BUY)
     {
      //---      
      level=NormalizeDouble(buy_point-CorrectValueBySymbolDigits(StopLoss*sym_point),sym_digits);
      //---    ,     (stops level), 
      //      ,    
      if(level<sym_down_level)
         return(level);
      //---    ,      bid
      else
        {
         level=NormalizeDouble(sym_bid-CorrectValueBySymbolDigits(StopLoss*sym_point),sym_digits);
         //---     ,    
         //        
         return(level<sym_down_level ? level : sym_down_level-sym_offset);
        }
     }
//---     SELL
   if(position_type==POSITION_TYPE_SELL)
     {
      //     - 
      level=NormalizeDouble(sell_point+CorrectValueBySymbolDigits(StopLoss*sym_point),sym_digits);
      //---    ,     (stops level), 
      //      ,    
      if(level>sym_up_level)
         return(level);
      //---    ,      ask
      else
        {
         level=NormalizeDouble(sym_ask+CorrectValueBySymbolDigits(StopLoss*sym_point),sym_digits);
         //---     ,    
         //        
         return(level>sym_up_level ? level : sym_up_level+sym_offset);
        }
     }
//---
   return(0.0);
  }
//+------------------------------------------------------------------+
//|   Trailing Stop                                   |
//+------------------------------------------------------------------+
void ModifyTrailingStop()
  {
//---     StopLoss
   if(TrailingStop>0 && StopLoss>0)
     {
      double         new_sl=0.0;       //     Stop loss
      bool           condition=false;  //     
      //---   / 
      pos_open=PositionSelect(_Symbol);
      //---   
      if(pos_open)
        {
         //---   
         GetSymbolProperties(S_ALL);
         //---   
         GetPositionProperties(P_ALL);
         //---    Stop Loss
         new_sl=CalculateTrailingStop(pos_type);
         //---           Trailing Stop
         switch(pos_type)
           {
            case POSITION_TYPE_BUY  :
               //---     Stop Loss ,
               //         
               condition=new_sl>pos_sl+CorrectValueBySymbolDigits(TrailingStop*sym_point);
               break;
            case POSITION_TYPE_SELL :
               //---     Stop Loss ,
               //         
               condition=new_sl<pos_sl-CorrectValueBySymbolDigits(TrailingStop*sym_point);
               break;
           }
         //---  Stop Loss ,     
         if(pos_sl>0)
           {
            //---      , ..   /, 
            //     ,    
            if(condition)
              {
               if(!trade.PositionModify(_Symbol,new_sl,pos_tp))
                  Print("   : ",GetLastError()," - ",ErrorDescription(GetLastError()));
              }
           }
         //---  Stop Loss ,    
         if(pos_sl==0)
           {
            if(!trade.PositionModify(_Symbol,new_sl,pos_tp))
               Print("   : ",GetLastError()," - ",ErrorDescription(GetLastError()));
           }
        }
     }
  }
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
bool IsTester()
  {
   return(MQL5InfoInteger(MQL5_TESTER));
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
bool IsOptimization()
  {
   return(MQL5InfoInteger(MQL5_OPTIMIZATION));
  }
//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+
bool IsVisualMode()
  {
   return(MQL5InfoInteger(MQL5_VISUAL_MODE));
  }
//+------------------------------------------------------------------+
//|       ,            |
//|                                         |
//+------------------------------------------------------------------+
bool IsRealtime()
  {
   if(!IsTester() && !IsOptimization() && !IsVisualMode())
      return(true);
   else
      return(false);
  }
//+------------------------------------------------------------------+
//|                                 |
//|------------------------------------------------------------------+
void SetInfoPanel()
  {
//---     
   if(IsVisualMode() || IsRealtime())
     {
      int               y_bg=18;             //    Y    
      int               y_property=32;       //    Y      
      int               line_height=12;      //  
      //---
      int               font_size=8;         //  
      string            font_name="Calibri"; // 
      color             font_color=clrWhite; //  
      //---
      ENUM_ANCHOR_POINT anchor=ANCHOR_RIGHT_UPPER; //      
      ENUM_BASE_CORNER  corner=CORNER_RIGHT_UPPER; //       
      //---    X
      int               x_first_column=120;  //   ( )
      int               x_second_column=10;  //   ( )
      //---    
      if(MQL5InfoInteger(MQL5_VISUAL_MODE))
        {
         y_bg=2;
         y_property=16;
        }
      //---      Y       
      int               y_prop_array[INFOPANEL_SIZE]={0};
      //---         
      for(int i=0; i<INFOPANEL_SIZE; i++)
        {
         if(i==0) y_prop_array[i]=y_property;
         else     y_prop_array[i]=y_property+line_height*i;
        }
      //---  -
      CreateEdit(0,0,"InfoPanelBackground","",corner,font_name,8,clrWhite,230,190,231,y_bg,0,C'15,15,15',true);
      //---  -
      CreateEdit(0,0,"InfoPanelHeader","  POSITION  PROPERTIES",corner,font_name,8,clrWhite,230,14,231,y_bg,1,clrFireBrick,true);
      //---       
      for(int i=0; i<INFOPANEL_SIZE; i++)
        {
         //---  
         CreateLabel(0,0,pos_prop_names[i],pos_prop_texts[i],anchor,corner,font_name,font_size,font_color,x_first_column,y_prop_array[i],2);
         //---  
         CreateLabel(0,0,pos_prop_values[i],GetPropertyValue(i),anchor,corner,font_name,font_size,font_color,x_second_column,y_prop_array[i],2);
        }
      //---
      ChartRedraw(); //  
     }
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
void DeleteInfoPanel()
  {
   DeleteObjectByName("InfoPanelBackground");   //   
   DeleteObjectByName("InfoPanelHeader");       //   
//---      
   for(int i=0; i<INFOPANEL_SIZE; i++)
      //+------------------------------------------------------------------+
      //|                                                                  |
      //+------------------------------------------------------------------+
     {
      DeleteObjectByName(pos_prop_names[i]);    //  
      DeleteObjectByName(pos_prop_values[i]);   //  
     }
//---
   ChartRedraw(); //  
  }
//+------------------------------------------------------------------+
//|                        |
//+------------------------------------------------------------------+
string GetPropertyValue(int number)
  {
//---         
//    ,  , Stop Loss  Take Profit
   string empty="-";
//---   ,    
   if(pos_open)
     {
      switch(number)
        {
         case 0  : return(pos_symbol);                                           break;
         case 1  : return(IntegerToString((int)pos_magic));                      break;
         //---   ,  ,  -  
         case 2  : return(pos_comment!="" ? pos_comment : empty);                break;
         case 3  : return(DoubleToString(pos_swap,2));                           break;
         case 4  : return(DoubleToString(pos_commission,2));                     break;
         case 5  : return(DoubleToString(pos_price,_Digits));                    break;
         case 6  : return(DoubleToString(pos_cprice,_Digits));                   break;
         case 7  : return(DoubleToString(pos_profit,2));                         break;
         case 8  : return(DoubleToString(pos_volume,2));                         break;
         case 9  : return(pos_sl!=0.0 ? DoubleToString(pos_sl,_Digits) : empty); break;
         case 10 : return(pos_tp!=0.0 ? DoubleToString(pos_tp,_Digits) : empty); break;
         case 11 : return(TimeToString(pos_time,TIME_DATE|TIME_MINUTES));        break;
         case 12 : return(IntegerToString((int)pos_id));                         break;
         case 13 : return(PositionTypeToString(pos_type));                       break;

         default : return(empty);
        }
     }
//---
//    ,     "-"
   return(empty);
  }
//+------------------------------------------------------------------+
//|                 |
//+------------------------------------------------------------------+
string GetDeinitReasonText(int reason_code)
  {
   string text="";
//---
   switch(reason_code)
     {
      case REASON_PROGRAM :     // 0
         text="   ,   ExpertRemove().";      break;
      case REASON_REMOVE :      // 1
         text=" '"+EXPERT_NAME+"'    .";                break;
      case REASON_RECOMPILE :   // 2
         text=" '"+EXPERT_NAME+"'  .";                break;
      case REASON_CHARTCHANGE : // 3
         text="     .";                             break;
      case REASON_CHARTCLOSE :  // 4
         text=" .";                                                     break;
      case REASON_PARAMETERS :  // 5
         text="    .";                     break;
      case REASON_ACCOUNT :     // 6
         text="  .";                                           break;
      case REASON_TEMPLATE :    // 7
         text="   .";                                    break;
      case REASON_INITFAILED :  // 8
         text=" ,   OnInit()   .";   break;
      case REASON_CLOSE :       // 9
         text="  .";                                               break;
      default : text="  .";
     }
//---
   return text;
  }
//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
string ErrorDescription(int error_code)
  {
   string error_string="";
//---
   switch(error_code)
     {
      //---    

      case 10004: error_string="";                                                         break;
      case 10006: error_string=" ";                                                break;
      case 10007: error_string="  ";                                        break;
      case 10008: error_string=" ";                                                  break;
      case 10009: error_string=" ";                                                break;
      case 10010: error_string="  ";                                       break;
      case 10011: error_string="  ";                                        break;
      case 10012: error_string="    ";                             break;
      case 10013: error_string=" ";                                             break;
      case 10014: error_string="   ";                                    break;
      case 10015: error_string="   ";                                     break;
      case 10016: error_string="   ";                                    break;
      case 10017: error_string=" ";                                              break;
      case 10018: error_string=" ";                                                    break;
      case 10019: error_string="   ";                                break;
      case 10020: error_string=" ";                                                 break;
      case 10021: error_string="    ";                     break;
      case 10022: error_string="     ";                        break;
      case 10023: error_string="  ";                                     break;
      case 10024: error_string="  ";                                          break;
      case 10025: error_string="   ";                                         break;
      case 10026: error_string="  ";                                 break;
      case 10027: error_string="   ";                     break;
      case 10028: error_string="   ";                               break;
      case 10029: error_string="   ";                                    break;
      case 10030: error_string="      ";        break;
      case 10031: error_string="    ";                              break;
      case 10032: error_string="     ";                   break;
      case 10033: error_string="     ";                break;
      case 10034: error_string="         ";  break;

      //---   

      case 0:  //   
      case 4001: error_string="  ";                                                                                                   break;
      case 4002: error_string="       ";                                                          break;
      case 4003: error_string="     ";                                                                                 break;
      case 4004: error_string="     ";                                                                            break;
      case 4005: error_string="    /   /     / ";                    break;
      case 4006: error_string="  ,       ";                                   break;
      case 4007: error_string="          ";                           break;
      case 4008: error_string="    ";                                                                                break;
      case 4009: error_string=" ";                                                                                                     break;
      case 4010: error_string="   / ";                                                                                        break;
      case 4011: error_string="    2 ";                                                                              break;
      case 4012: error_string=" ";                                                                                                             break;
      case 4013: error_string="  ";                                                                                                         break;
      case 4014: error_string="     ";                                                                                       break;
      //-- 
      case 4101: error_string="  ";                                                                                                 break;
      case 4102: error_string="  ";                                                                                                              break;
      case 4103: error_string="  ";                                                                                                                break;
      case 4104: error_string="   ,     ";                                                                       break;
      case 4105: error_string="  ";                                                                                                         break;
      case 4106: error_string="       ";                                                                              break;
      case 4107: error_string="   ";                                                                                                  break;
      case 4108: error_string="   ";                                                                                                     break;
      case 4109: error_string="   ";                                                                                        break;
      case 4110: error_string="   ";                                                                                                   break;
      case 4111: error_string="   ";                                                                                                     break;
      case 4112: error_string="   ";                                                                                                   break;
      case 4113: error_string=",   ,  ";                                                                             break;
      case 4114: error_string="     ";                                                                                      break;
      case 4115: error_string="     ";                                                                                        break;
      case 4116: error_string="     ";                                                                                        break;
      //--  
      case 4201: error_string="     ";                                                                                        break;
      case 4202: error_string="   ";                                                                                                    break;
      case 4203: error_string="    ";                                                                           break;
      case 4204: error_string="  ,  ";                                                                              break;
      case 4205: error_string="  ,  ";                                                                              break;
      //-- MarketInfo
      case 4301: error_string=" ";                                                                                                              break;
      case 4302: error_string="    MarketWatch";                                                                                                  break;
      case 4303: error_string="   ";                                                                                        break;
      case 4304: error_string="    (  )";                                                                                break;
      //--   
      case 4401: error_string="   !";                                                                                               break;
      case 4402: error_string="   ";                                                                                        break;
      //-- Global_Variables
      case 4501: error_string="     ";                                                                          break;
      case 4502: error_string="        ";                                                       break;
      case 4510: error_string="   ";                                                                                                     break;
      case 4511: error_string="   ";                                                                                                   break;
      case 4512: error_string="   ";                                                                                      break;
      case 4513: error_string="   ";                                                                                      break;
      case 4514: error_string="     ftp";                                                                                                break;
      //--   
      case 4601: error_string="     ";                                                                      break;
      case 4602: error_string="    ";                                                                                    break;
      //--   
      case 4603: error_string="    ";                                                                   break;
      //-- Account
      case 4701: error_string="   ";                                                                                          break;
      case 4751: error_string="   ";                                                                                       break;
      case 4752: error_string="   ";                                                                                                 break;
      case 4753: error_string="  ";                                                                                                              break;
      case 4754: error_string="  ";                                                                                                                 break;
      case 4755: error_string="  ";                                                                                                               break;
      case 4756: error_string="    ";                                                                                            break;
      //-- 
      case 4801: error_string=" ";                                                                                                              break;
      case 4802: error_string="    ";                                                                                                  break;
      case 4803: error_string="    ";                                                                                   break;
      case 4804: error_string="       ";                                                                           break;
      case 4805: error_string="   ";                                                                                                break;
      case 4806: error_string="   ";                                                                                                   break;
      case 4807: error_string="  ";                                                                                                      break;
      case 4808: error_string="     ";                                                                      break;
      case 4809: error_string="    ";                                                                                   break;
      case 4810: error_string="        ";                                                        break;
      case 4811: error_string="       ";                                                                    break;
      case 4812: error_string="    ";                                                                            break;
      //--  
      case 4901: error_string="     ";                                                                                               break;
      case 4902: error_string="     ";                                                                                                 break;
      case 4903: error_string="      ";                                                                                       break;
      case 4904: error_string="        ";                                                                       break;
      //--  
      case 5001: error_string="      64 ";                                                                              break;
      case 5002: error_string="  ";                                                                                                          break;
      case 5003: error_string="   ";                                                                                                       break;
      case 5004: error_string="  ";                                                                                                           break;
      case 5005: error_string="    ";                                                                                             break;
      case 5006: error_string="  ";                                                                                                           break;
      case 5007: error_string="      ,    ";                                                                  break;
      case 5008: error_string="  ";                                                                                                           break;
      case 5009: error_string="     ";                                                                                              break;
      case 5010: error_string="     ";                                                                                              break;
      case 5011: error_string="     ";                                                                                            break;
      case 5012: error_string="     ";                                                                                           break;
      case 5013: error_string="       CSV";                                                                                   break;
      case 5014: error_string="     CSV";                                                                                                 break;
      case 5015: error_string="  ";                                                                                                             break;
      case 5016: error_string="    ,      ";                                                              break;
      case 5017: error_string="      ,    ";                                                     break;
      case 5018: error_string="  ,  ";                                                                                                       break;
      case 5019: error_string="  ";                                                                                                              break;
      case 5020: error_string="    ";                                                                                                    break;
      case 5021: error_string="  ";                                                                                                        break;
      case 5022: error_string="  ";                                                                                                        break;
      case 5023: error_string=" ,   ";                                                                                                       break;
      case 5024: error_string="    ";                                                                                                break;
      case 5025: error_string="    (,          )";               break;
      //--  
      case 5030: error_string="   ";                                                                                                               break;
      case 5031: error_string="   ";                                                                                                         break;
      case 5032: error_string="   ";                                                                                                        break;
      case 5033: error_string="    ";                                                                                             break;
      case 5034: error_string="   ";                                                                                                  break;
      case 5035: error_string="  ,  ";                                                                                              break;
      case 5036: error_string="  , ,  ULONG_MAX";                                                                                    break;
      case 5037: error_string="  ";                                                                                                      break;
      case 5038: error_string="  ,  ";                                                                                 break;
      case 5039: error_string=" ,   ";                                                                                 break;
      case 5040: error_string="   string";                                                                                                break;
      case 5041: error_string="   ";                                                                                                     break;
      case 5042: error_string="    0,  ";                                                                                 break;
      case 5043: error_string="      ";                                                                                 break;
      case 5044: error_string="  ";                                                                                                       break;
      //--   
      case 5050: error_string="  .        ,      ";   break;
      case 5051: error_string="    AS_SERIES,    ";                                                             break;
      case 5052: error_string="  ,     ";                                                                break;
      case 5053: error_string="  ";                                                                                                            break;
      case 5054: error_string="   ";                                                                                                     break;
      case 5055: error_string="   ";                                                                                                   break;
      case 5056: error_string="    ";                                                                                            break;
      case 5057: error_string="    double";                                                                                                  break;
      case 5058: error_string="    float";                                                                                                   break;
      case 5059: error_string="    long";                                                                                                    break;
      case 5060: error_string="    int";                                                                                                     break;
      case 5061: error_string="    short";                                                                                                   break;
      case 5062: error_string="    char";                                                                                                    break;
      //--  

      default: error_string="  ";
     }
//---
   return(error_string);
  }
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---   
   CheckNewBar();
//---     
   GetPositionProperties(P_ALL);
//---   
   SetInfoPanel();
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---     
   Print(GetDeinitReasonText(reason));
//---    
   if(reason==REASON_REMOVE)
      //---     ,     
      DeleteInfoPanel();
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---    , 
   if(!CheckNewBar())
      return;
//---    
   else
     {
      GetBarsData();          //   
      TradingBlock();         //    
      ModifyTrailingStop();   //   Trailing Stop
     }
//---       
   GetPositionProperties(P_ALL);
//---   
   SetInfoPanel();
  }
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void OnTrade()
  {
//---        
   GetPositionProperties(P_ALL);
//---   
   SetInfoPanel();
  }
//+------------------------------------------------------------------+
